

CREATE TABLE actionlog (
  alogid int not null identity primary key,
  gsid int,
  userid int,
  logname varchar(255),
  logmessage varchar(255),
  rawobj text,
  logdate int,
  sid int,
  rectype varchar(255),
  recid int,
  wssdone bit
);

  
create index logdate on actionlog (logdate);
create index userid on actionlog (userid);
create index wssdone on actionlog (wssdone);
create index gsid on actionlog (gsid);


CREATE TABLE gss (
  gsid int not null identity primary key,
  gsname varchar(255),
  stripecustomerid varchar(255),
  gsexpiry int,
  gstier int
);

create index gsname on gss (gsname);
create index gsexpiry on gss (gsexpiry);

SET IDENTITY_INSERT gss On;
INSERT INTO gss(gsid,gsname,stripecustomerid,gsexpiry,gstier) VALUES (1, 'Default Instance', '', 0, 0);
SET IDENTITY_INSERT gss Off;

CREATE TABLE users (
  userid int not null identity primary key,
  gsid int,
  login varchar(255),
  dispname varchar(255),
  active bit,
  virtualuser bit,
  password varchar(255),
  passreset bit,
  groupnames text,
  keyfilehash varchar(255),
  needkeyfile bit,
  usesms bit,
  smscell varchar(255),  
  smscode varchar(255),  
  certhash varchar(255),
  needcert bit,
  certname varchar(255)
);

create index active on users (active);
create index virtualuser on users (virtualuser);
create index gsid on users (gsid);

SET IDENTITY_INSERT users On;
INSERT INTO users (userid,gsid,login,dispname,active,virtualuser,password,passreset,groupnames,keyfilehash,needkeyfile,usesms,smscell,smscode,certhash,needcert,certname) VALUES (101,1,'admin','Admin',1,0,'uSAsxyX3v44q3+/4Md7lzkhaNlIvTHFTMkZsN1lFRWVMRzB2UlloZTJqWHRjSG9mRDgybTI3U0xZUjhzYVhUeDlUZ2dLQ283QkUrVmExaEY=',0,'users|admins|reportsettings|systemplateuse|systemplate|accounts|dbadmin|upgrademods',null,0,0,'','',null,0,null);
SET IDENTITY_INSERT users Off;


CREATE TABLE templates (
  templateid int not null identity primary key,
  templatename varchar(255),
  templatetypeid int,
  templatetext text
);

create index templatetypeid on templates (templatetypeid);

CREATE TABLE templatetypes (
  templatetypeid int not null identity primary key,
  gsid int,
  templatetypename varchar(255),
  templatetypekey varchar(255),
  activetemplateid int,
  templatetypegroup varchar(255),
  plugins varchar(255),
  classes varchar(255)
);

create index templatetypekey on templatetypes (templatetypekey);
create index activetemplateid on templatetypes (activetemplateid);
create index gsid on templatetypes (gsid);


CREATE TABLE templatevars (
  templatevarid int not null identity primary key,
  templatevarname varchar(255),
  templatevardesc varchar(255),
  templatetypeid int
);
    

CREATE TABLE reports (
  reportid int not null identity primary key,
  gsid int,
  reportname_en varchar(255),
  reportgroup_en varchar(255),
  reportdesc_en text,
  reportname_de varchar(255),
  reportgroup_de varchar(255),
  reportdesc_de text,
  reportname_pt varchar(255),
  reportgroup_pt varchar(255),
  reportdesc_pt text,
  reportname_zh varchar(255),
  reportgroup_zh varchar(255),
  reportdesc_zh text,
  reportfunc varchar(255),
  reportkey varchar(255),
  reportgroupnames varchar(255),
  gyrosys bit,
);

create index gsid on reports (gsid);

SET IDENTITY_INSERT reports On;
INSERT INTO reports (reportid,gsid,reportname_en,reportgroup_en,reportdesc_en,reportname_de,reportgroup_de,reportdesc_de,reportname_pt,reportgroup_pt,reportdesc_pt,reportname_zh,reportgroup_zh,reportdesc_zh,reportfunc,reportkey,reportgroupnames,gyrosys) VALUES (1, 0, 'Activity Log', 'Security', 'This report is mostly used by system administrators for diagnostic purposes.', 'Aktivittsprotokoll', 'Sicherheit', '', 'Registro de Atividade', '', 'admins', '1', '????', '????', '', 'actionlog', 'admins|reportsettings|systemplateuse|systemplate', 1);
SET IDENTITY_INSERT reports Off;

     